/*********************************************************************
 *                    Flowcode Custom Component Code
 *
 * File: Custom_Code.c
 *
 * (c) 2007 Matrix Multimedia Ltd.
 * http://www.matrixmultimedia.com
 *
 * Software License Agreement
 *
 * The software supplied herewith by Matrix Multimedia Ltd (the
 * Company) for its Flowcode graphical programming language is
 * intended and supplied to you, the Companys customer, for use
 * solely and exclusively on the Company's products. The software
 * is owned by the Company, and is protected under applicable
 * copyright laws. All rights are reserved. Any use in violation
 * of the foregoing restrictions may subject the user to criminal
 * sanctions under applicable laws, as well as to civil liability
 * for the breach of the terms and conditions of this licence.
 *
 * THIS SOFTWARE IS PROVIDED IN AN AS IS CONDITION. NO WARRANTIES,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 * Changelog:
 *
 *  date  | by | description
 * -------+----+-----------------------------------------------------
 * 240407 | ST | Created
 * 200309 | JV | DMXread 8 bytes at specified adress
 *        |    |
 *        |    |
 *        |    |
 *
 *
 *
 ********************************************************************/

/*********************************************************************

 Return & parameter types:
   void
   char
   short
   char*

 Pin directions:
   0 = OUTPUT
   2 = INPUT
   3 = BIDIRECTIONAL

 Macro substitutions:
   %a = ??
   %b = ??
   %c = ??
   %d = ??
   %e = ??
   %f = ??
   %g = ??
   %h = ??
   %i = ??
   %j = ??

**********************************************************************

[Settings]
CLSID={4B174520-75AB-4B14-A0F7-2AA6C203F1DC}
IsAnalogue=0
MultipleAllowed=0
Description=DMX receiver

**********************************************************************

[Port]
DesiredPort=0
PortMandatory=0
SamePortAsID=0

[Pins]
Count=0

[PinPort]
# PORTA = 0
# PORTB = 1
# PORTC = 2
# PORTD = 3
# PORTE = 4

[PinDesiredBit]

[PinDirection]
# DIR_INPUT = 2
# DIR_OUTPUT = 0
# DIR_BIDIRECTIONAL = 3

[PinMustUsePort]
# boolean

[SamePortAsPinX]
# -1 = any pin
# otherwise, the pin number

[PinMustUsePin]
# boolean

[PinValue]
# boolean (0 = off, 1 = on)

**********************************************************************

[MacroNames]
Count=3
1=GetDefines
2=SetAdress
3=ReadByte


[MacroReturns]
1=void
2=void
3=char

[MacroIsPrivate]
1=1
2=0
3=0


[MacroParameters_GetDefines]
Count=0

[MacroParamTypes_GetDefines]


[MacroParameters_SetAdress]
Count=8
1=nAdress1
2=nAdress2
3=nAdress3
4=nAdress4
5=nAdress5
6=nAdress6
7=nAdress7
8=nAdress8

[MacroParamTypes_SetAdress]
1=short
2=short
3=short
4=short
5=short
6=short
7=short
8=short

[MacroParameters_ReadByte]
Count=1
1=nByte

[MacroParamTypes_ReadByte]
1=short







 ********************************************************************/

/********************************************************************
 * ADDITIONAL CODE
 ********************************************************************/

/*InitialisationCode_Start*/
txsta.BRGH = 1;        // Set baudrate to high speed (p113)
spbrg      = 0x04;     // Set Baud Rate Generator Registor to 245760 i.s.o 250000 error 1,70%
txsta.SYNC = 0;        // Enable asynchronous serial port
rcsta.SPEN = 1;        // Enable asynchronous serial port
pie1.RCIE  = 1;        // Enable interrupts
rcsta.RX9  = 1;        // Enable 9-bit reception
rcsta.CREN = 1;        // Enable reception
intcon.GIE = 1;        // Global interrupt enable
intcon.PEIE = 1;       // Peripheral intterupt ennable
/*InitialisationCode_End*/

/*InterruptCode_Start*/
if(pir1 & (1 << RCIF)){
  if(rcsta.FERR){
    DMXAdressCounter = 0;
    data_temp = rcreg;
  } else {
    char i = 0;
    DMXAdressCounter++;
    data_temp = rcreg;
	while (i<8)
	{
	  if(DMXAdressCounter == DMXAdress[i]){
	 	DATA[i] = data_temp;
	  }
	  i++;
	}
  }
  clear_bit(pir1, RCIF);
 //pir1.RCIF = 0;      // IS read only, cleared by hardware on RCREG read
}
/*InterruptCode_End*/




/********************************************************************
 * FUNCTIONS
 ********************************************************************/


void GetDefines()
{
/*Macro_GetDefines_Start*/

}  //Dummy end of function to allow defines to be added correctly

//common defines
#define MX_CUSTOM_1  %a
#define MX_CUSTOM_2  %b
#define MX_CUSTOM_3  %c
#define MX_CUSTOM_4  %d
#define MX_CUSTOM_5  %e
#define MX_CUSTOM_6  %f
#define MX_CUSTOM_7  %g
#define MX_CUSTOM_8  %h
#define MX_CUSTOM_9  %i
#define MX_CUSTOM_10 %j


//global variables
char DATA[8] = 0;
short DMXAdress[8] = 0;
char data_temp = 0;
short DMXAdressCounter = 0;


// Dummy function to close the defines section off
void CUSTOM_Dummy_Function();
void CUSTOM_Dummy_Function()
{

/*Macro_GetDefines_End*/
}


void SetAdress(short nAdress1, short nAdress2, short nAdress3, short nAdress4, short nAdress5, short nAdress6, short nAdress7, short nAdress8)
{
/*Macro_SetAdress_Start*/
  DMXAdress[0] = nAdress1+1;
  DMXAdress[1] = nAdress2+1;
  DMXAdress[2] = nAdress3+1;
  DMXAdress[3] = nAdress4+1;
  DMXAdress[4] = nAdress5+1;
  DMXAdress[5] = nAdress6+1;
  DMXAdress[6] = nAdress7+1;
  DMXAdress[7] = nAdress8+1;
/*Macro_SetAdress_End*/
}

char ReadByte(short nByte){
/*Macro_ReadByte_Start*/
	char i;
	i = DATA[nByte];
	return(i);
/*Macro_ReadByte_End*/
}